{% extends 'base-public.html.twig' %}

{% block body %}
    <h3>Tableau d'affichage - Toulouse Compans</h3>

<div class="nk-block">
    <div id="kanban" class="nk-kanban"><div class="kanban-container" style="width: 740px;">
            {% for category in boardCategories %}
                <div data-id="_open" data-order="1" class="kanban-board" style="width: 320px; margin-left: 0px; margin-right: 0px;">
                    <header class="kanban-board-header kanban-{{ category.color }}"><div class="kanban-title-board">
                            <div class="kanban-title-content">
                                <h6 class="title">{{ category.title }}</h6>
                                <span class="badge rounded-pill bg-outline-light text-dark">{{ category.items|length }}</span>
                            </div>
                            <div class="kanban-title-content">
                                <div class="drodown">
                                    <a href="#" class="dropdown-toggle btn btn-sm btn-icon btn-trigger me-n1" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                    <div class="dropdown-menu dropdown-menu-end">
                                        <ul class="link-list-opt no-bdr">
                                            <li><a href="#"><em class="icon ni ni-edit"></em><span>Modifier la catégorie</span></a></li>
                                            <li><a href="#"><em class="icon ni ni-plus-sm"></em><span>Ajouter un document</span></a></li>
                                        </ul>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </header>
                    <main class="kanban-drag">
                        {% for item in category.items %}
                            <div class="kanban-item">
                                <div class="kanban-item-title">
                                    <h6 class="title">{{ item.title }}</h6>
                                    <div class="drodown">
                                        <a href="#" class="dropdown-toggle btn btn-sm btn-icon btn-trigger me-n1" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                        <div class="dropdown-menu dropdown-menu-end">
                                            <ul class="link-list-opt no-bdr">
                                                <li><a href="#"><em class="icon ni ni-edit"></em><span>Modifier</span></a></li>
                                            </ul>
                                        </div>
                                    </div>

                                </div>
                                <div class="kanban-item-text">
                                    <img data-pdf-thumbnail-file="{{ upload_path }}{{ item.documentFileName }}">
                                    <span class="text-muted text-sm-start">le {{ item.uploadedAt|date('d/m/y à H:i') }}</span>
                                </div>
                            </div>
                        {% endfor %}

                    </main>
                    <footer>
                        <a href="{{ path('app_board_boarditem_add', {'categoryId': category.id}) }}" class="kanban-add-task btn btn-block"><em class="icon ni ni-plus-sm"></em><span>Ajouter un document</span></a>
                    </footer>
                </div>
            {% endfor %}

    </div>
</div>
{% endblock %}

{% block javascripts %}
    <script >
    /**
 * Find all img elements with data-pdf-thumbnail-file attribute,
 * then load pdf file given in the attribute,
 * then use pdf.js to draw the first page on a canvas,
 * then convert it to base64,
 * then set it as the img src.
 */
var createPDFThumbnails = function(){

    var worker = null;
    var loaded = false;
    var renderQueue = [];

    // select all img elements with data-pdf-thumbnail-file attribute
    var nodesArray = Array.prototype.slice.call(document.querySelectorAll('img[data-pdf-thumbnail-file]'));

    if (!nodesArray.length) {
        // No PDF found, don't load PDF.js
        return;
    }

    if (!loaded && typeof(pdfjsLib) === 'undefined') {
        var src = document.querySelector('script[data-pdfjs-src]').getAttribute('data-pdfjs-src');

        if (!src) {
            throw Error('PDF.js URL not set in "data-pdfjs-src" attribute: cannot load PDF.js');
        }

        var script = document.createElement('script');
        script.src = src;
        document.head.appendChild(script).onload = renderThumbnails;
        loaded = true;
    }
    else {
        renderThumbnails();
    }

    function renderThumbnails() {
        if (!pdfjsLib) {
            throw Error("pdf.js failed to load. Check data-pdfjs-src attribute.");
        }

        nodesArray.forEach(function(element) {
            if (null === worker) {
                worker = new pdfjsLib.PDFWorker();
            }

            var filePath = element.getAttribute('data-pdf-thumbnail-file');
            var imgWidth = element.getAttribute('data-pdf-thumbnail-width');
            var imgHeight = element.getAttribute('data-pdf-thumbnail-height');

            pdfjsLib.getDocument({url: filePath, worker: worker}).promise.then(function (pdf) {
                pdf.getPage(1).then(function (page) {
                    var canvas = document.createElement("canvas");
                    var viewport = page.getViewport({scale: 1.0});
                    var context = canvas.getContext('2d');

                    if (imgWidth) {
                        viewport = page.getViewport({scale: imgWidth / viewport.width});
                    } else if (imgHeight) {
                        viewport = page.getViewport({scale: imgHeight / viewport.height});
                    }

                    canvas.height = viewport.height;
                    canvas.width = viewport.width;

                    page.render({
                        canvasContext: context,
                        viewport: viewport
                    }).promise.then(function () {
                        element.src = canvas.toDataURL();
                    });
                }).catch(function() {
                    console.log("pdfThumbnails error: could not open page 1 of document " + filePath + ". Not a pdf ?");
                });
            }).catch(function() {
                console.log("pdfThumbnails error: could not find or open document " + filePath + ". Not a pdf ?");
            });
        });
    }
};

if (
    document.readyState === "complete" ||
    (document.readyState !== "loading" && !document.documentElement.doScroll)
) {
    createPDFThumbnails();
} else {
    document.addEventListener("DOMContentLoaded", createPDFThumbnails);
}
</script>
{% endblock javascripts %}